import _Object$values from 'babel-runtime/core-js/object/values';
import _typeof from 'babel-runtime/helpers/typeof';
import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _Object$assign from 'babel-runtime/core-js/object/assign';
import _slicedToArray from 'babel-runtime/helpers/slicedToArray';
import _Object$entries from 'babel-runtime/core-js/object/entries';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';

var Util = function () {
  function Util(IO) {
    _classCallCheck(this, Util);

    this.IO = IO;
  }

  _createClass(Util, [{
    key: 'basename',
    value: function basename(fullname) {
      return fullname.replace(/^[\s\S]*\/(?=[^/]*$)/, '');
    }
  }, {
    key: 'mapValues',
    value: function mapValues(obj, f) {
      return _Object$entries(obj).reduce(function (prev, _ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            key = _ref2[0],
            value = _ref2[1];

        return _Object$assign({}, prev, _defineProperty({}, key, f(value)));
      }, {});
    }
  }, {
    key: 'mapKeyValues',
    value: function mapKeyValues(obj, f) {
      return _Object$assign.apply(Object, [{}].concat(_toConsumableArray(_Object$entries(obj).map(f))));
    }
  }, {
    key: 'isFunction',
    value: function isFunction(obj) {
      return typeof obj === 'function';
    }
  }, {
    key: 'isObject',
    value: function isObject(obj) {
      return (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object' && obj !== null;
    }
  }, {
    key: 'isGenerator',
    value: function isGenerator(obj) {
      return this.isObject(obj) && this.isFunction(obj.next) && this.isFunction(obj.throw);
    }
  }, {
    key: 'isGeneratorFunction',
    value: function isGeneratorFunction(obj) {
      if (!this.isFunction(obj)) return false;
      if (obj.constructor.name === 'GeneratorFunction' || obj.constructor.displayName === 'GeneratorFunction') return true;
      return this.isGenerator(obj.constructor.prototype);
    }
  }, {
    key: 'isEffect',
    value: function isEffect(obj) {
      return this.isObject(obj) && obj[this.IO];
    }
  }, {
    key: 'isForkEffect',
    value: function isForkEffect(obj) {
      return this.isEffect(obj) && this.isObject(obj.FORK) && this.isFunction(obj.FORK.fn) && Array.isArray(obj.FORK.args);
    }
  }, {
    key: 'retrieveWorker',
    value: function retrieveWorker(saga) {
      if (!this.isForkEffect(saga)) {
        throw new Error('Invalid saga: The value must be a redux-saga FORK effect.');
      }

      var _arr = [saga.FORK.fn].concat(_toConsumableArray(saga.FORK.args));

      for (var _i = 0; _i < _arr.length; _i++) {
        var arg = _arr[_i];
        if (this.isGeneratorFunction(arg)) return arg;
      }
      throw new Error('Invalid saga: Generator function not found.');
    }
  }, {
    key: 'retrieveWorkers',
    value: function retrieveWorkers(sagas) {
      return this.mapValues(sagas, this.retrieveWorker.bind(this));
    }
  }, {
    key: 'flattenSagas',
    value: function flattenSagas() {
      var storage = [];

      for (var _len = arguments.length, sagas = Array(_len), _key = 0; _key < _len; _key++) {
        sagas[_key] = arguments[_key];
      }

      while (sagas.length) {
        var saga = sagas.shift();
        if (!this.isObject(saga)) continue;
        if (saga[this.IO]) storage.push(saga);
        sagas.unshift.apply(sagas, _toConsumableArray(_Object$values(saga)));
      }
      return storage;
    }
  }]);

  return Util;
}();

export default Util;