import _regeneratorRuntime from 'babel-runtime/regenerator';
import { fork as _fork, put, spawn as _spawn, takeEvery as _takeEvery, takeLatest as _takeLatest, throttle as _throttle } from 'redux-saga/effects';
import { IO, isGeneratorFunction, mapValues } from './utils';

var putYields = /*#__PURE__*/_regeneratorRuntime.mark(function putYields(g) {
  var value, done, _g$next, _g$throw, _g$next2, _g$throw2;

  return _regeneratorRuntime.wrap(function putYields$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          value = void 0, done = void 0;

          try {
            _g$next = g.next();
            value = _g$next.value;
            done = _g$next.done;
          } catch (e) {
            _g$throw = g.throw(e);
            value = _g$throw.value;
            done = _g$throw.done;
          }

        case 2:
          if (done) {
            _context.next = 21;
            break;
          }

          if (!value || !value[IO]) {
            value = put(value);
          }
          _context.prev = 4;
          _context.t0 = g;
          _context.next = 8;
          return value;

        case 8:
          _context.t1 = _context.sent;
          _g$next2 = _context.t0.next.call(_context.t0, _context.t1);
          value = _g$next2.value;
          done = _g$next2.done;
          _context.next = 19;
          break;

        case 14:
          _context.prev = 14;
          _context.t2 = _context['catch'](4);
          _g$throw2 = g.throw(_context.t2);
          value = _g$throw2.value;
          done = _g$throw2.done;

        case 19:
          _context.next = 2;
          break;

        case 21:
          return _context.abrupt('return', value);

        case 22:
        case 'end':
          return _context.stop();
      }
    }
  }, putYields, this, [[4, 14]]);
});
var putReturn = /*#__PURE__*/_regeneratorRuntime.mark(function putReturn(value) {
  return _regeneratorRuntime.wrap(function putReturn$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          if (!(value !== undefined)) {
            _context2.next = 3;
            break;
          }

          _context2.next = 3;
          return put(value);

        case 3:
        case 'end':
          return _context2.stop();
      }
    }
  }, putReturn, this);
});
var processFunction = /*#__PURE__*/_regeneratorRuntime.mark(function processFunction(fn) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return _regeneratorRuntime.wrap(function processFunction$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          _context3.t0 = putReturn;

          if (!isGeneratorFunction(fn)) {
            _context3.next = 6;
            break;
          }

          return _context3.delegateYield(putYields(fn.apply(undefined, args)), 't2', 3);

        case 3:
          _context3.t1 = _context3.t2;
          _context3.next = 7;
          break;

        case 6:
          _context3.t1 = fn.apply(undefined, args);

        case 7:
          _context3.t3 = _context3.t1;
          return _context3.delegateYield((0, _context3.t0)(_context3.t3), 't4', 9);

        case 9:
        case 'end':
          return _context3.stop();
      }
    }
  }, processFunction, this);
});

export var enhance = function enhance(saga, onError) {
  return (/*#__PURE__*/_regeneratorRuntime.mark(function enhancedSaga() {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return _regeneratorRuntime.wrap(function enhancedSaga$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.prev = 0;
              return _context4.delegateYield(processFunction.apply(undefined, [saga].concat(args)), 't0', 2);

            case 2:
              _context4.next = 9;
              break;

            case 4:
              _context4.prev = 4;
              _context4.t1 = _context4['catch'](0);

              if (onError) {
                _context4.next = 8;
                break;
              }

              throw _context4.t1;

            case 8:
              return _context4.delegateYield(processFunction.apply(undefined, [onError, _context4.t1].concat(args)), 't2', 9);

            case 9:
            case 'end':
              return _context4.stop();
          }
        }
      }, enhancedSaga, this, [[0, 4]]);
    })
  );
};
export var enhancibleForkerThunks = {
  takeEvery: function takeEvery(onError) {
    return function (patternOrChannel, worker) {
      for (var _len3 = arguments.length, args = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
        args[_key3 - 2] = arguments[_key3];
      }

      return _takeEvery.apply(undefined, [patternOrChannel, enhance(worker, onError)].concat(args));
    };
  },
  takeLatest: function takeLatest(onError) {
    return function (patternOrChannel, worker) {
      for (var _len4 = arguments.length, args = Array(_len4 > 2 ? _len4 - 2 : 0), _key4 = 2; _key4 < _len4; _key4++) {
        args[_key4 - 2] = arguments[_key4];
      }

      return _takeLatest.apply(undefined, [patternOrChannel, enhance(worker, onError)].concat(args));
    };
  },
  throttle: function throttle(onError) {
    return function (ms, pattern, worker) {
      for (var _len5 = arguments.length, args = Array(_len5 > 3 ? _len5 - 3 : 0), _key5 = 3; _key5 < _len5; _key5++) {
        args[_key5 - 3] = arguments[_key5];
      }

      return _throttle.apply(undefined, [ms, pattern, enhance(worker, onError)].concat(args));
    };
  },
  fork: function fork(onError) {
    return function (fn) {
      for (var _len6 = arguments.length, args = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
        args[_key6 - 1] = arguments[_key6];
      }

      return _fork.apply(undefined, [enhance(fn, onError)].concat(args));
    };
  },
  spawn: function spawn(onError) {
    return function (fn) {
      for (var _len7 = arguments.length, args = Array(_len7 > 1 ? _len7 - 1 : 0), _key7 = 1; _key7 < _len7; _key7++) {
        args[_key7 - 1] = arguments[_key7];
      }

      return _spawn.apply(undefined, [enhance(fn, onError)].concat(args));
    };
  }
};
export var enhancedForkers = mapValues(enhancibleForkerThunks, function (thunk) {
  return thunk(enhance);
});