import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _Object$entries from 'babel-runtime/core-js/object/entries';
import _getIterator from 'babel-runtime/core-js/get-iterator';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _slicedToArray from 'babel-runtime/helpers/slicedToArray';
import _Object$assign from 'babel-runtime/core-js/object/assign';
import _Object$getOwnPropertySymbols from 'babel-runtime/core-js/object/get-own-property-symbols';
import _typeof from 'babel-runtime/helpers/typeof';
import _regeneratorRuntime from 'babel-runtime/regenerator';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import { createAction, handleActions } from 'redux-actions';
import camelCase from 'redux-actions/lib/utils/camelCase';
import schema from './schema';
import Enhancer from './Enhancer';
import Util from './Util';

var Moducks = function () {
  function Moducks(config) {
    _classCallCheck(this, Moducks);

    this.config = schema.validateSync(config);
    this.util = new Util(this.extractIOSymbol());
    this.enhancer = new Enhancer(this.util, this.config.effects);
  }

  _createClass(Moducks, [{
    key: 'extractIOSymbol',
    value: function extractIOSymbol() {
      var task = this.config.effects.fork( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
      if ((typeof task === 'undefined' ? 'undefined' : _typeof(task)) === 'object' && task !== null) {
        var string = '@@redux-saga/IO';
        if (task[string]) return string;
        var symbol = _Object$getOwnPropertySymbols(task).find(function (symbol) {
          return symbol.toString().startsWith('Symbol(@@redux-saga/IO)');
        });
        if (task[symbol]) return symbol;
      }
      throw new Error('Cannot find symbol: @@redux-saga/IO');
    }
  }, {
    key: 'thunkifyMainGeneratorFunction',
    value: function thunkifyMainGeneratorFunction(saga) {
      var _this = this;

      return function (_ref) {
        var type = _ref.type,
            defaultEffect = _ref[_this.config.defaultEffect];
        return defaultEffect(type, saga);
      };
    }
  }, {
    key: 'thunkifyAdditionalGeneratorFunction',
    value: function thunkifyAdditionalGeneratorFunction(saga) {
      return function (_ref2) {
        var fork = _ref2.fork;
        return fork(saga);
      };
    }
  }, {
    key: 'initializeMainSaga',
    value: function initializeMainSaga(saga, type, onError) {
      var errLabels = ['Invalid saga for ' + type, this.config.defaultEffect];
      return this.initializeSaga(this.thunkifyMainGeneratorFunction, saga, errLabels, { type: type }, onError);
    }
  }, {
    key: 'initializeAdditionalSaga',
    value: function initializeAdditionalSaga(saga, actions, sagaName) {
      var errLabels = ['Invalid additional saga ' + sagaName, 'fork'];
      return this.initializeSaga(this.thunkifyAdditionalGeneratorFunction, saga, errLabels, actions);
    }
  }, {
    key: 'initializeSaga',
    value: function initializeSaga(thunkify, saga, errLabels, actions, onError) {
      var _this2 = this;

      if (typeof saga === 'function') saga = (this.util.isGeneratorFunction(saga) ? thunkify.call(this, saga) : saga)(_Object$assign({}, actions, this.enhancer.createEnhancedForkers(onError), {
        enhance: function enhance(saga) {
          return _this2.enhancer.enhance(saga, onError);
        }
      }));
      if (this.util.isGeneratorFunction(saga)) return this.enhancer.enhancedForkers.fork(saga);
      if (this.util.isForkEffect(saga)) return saga;
      throw new Error(errLabels[0] + ': It must be specified as one of them: \n' + ('  - generator function (=> automatically invoked by enhanced ' + errLabels[1] + '())\n') + '  - thunk that returns generator function (=> automatically invoked by enhanced fork())\n' + '  - thunk that returns redux-saga FORK effect\n' + '  - redux-saga FORK effect');
    }
  }, {
    key: 'createModule',
    value: function createModule(moduleName, definitions) {
      var _Object$assign2;

      var initialState = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      var reducerMap = {};
      var actions = {};
      var actionCreators = {};
      var sagas = {};

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = _getIterator(_Object$entries(definitions)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref3 = _step.value;

          var _ref4 = _slicedToArray(_ref3, 2);

          var rawType = _ref4[0];
          var definition = _ref4[1];


          var withApp = this.config.appName && !/^!?([*@])\1/.test(rawType);
          var withModule = !/^!?(?:\*|@{2})/.test(rawType);
          var useFullTypeAsKey = !withModule && /^!/.test(rawType);

          var type = rawType.replace(/^!?\*{0,2}/, '');
          var baseType = this.util.basename(type);
          var camelBaseType = camelCase(baseType);
          var fullType = '' + (withApp ? '@@' + this.config.appName + '/' : '') + (withModule ? moduleName + '/' : '') + type;

          var _ref7 = typeof definition === 'function' ? { reducer: definition } : definition,
              creator = _ref7.creator,
              reducer = _ref7.reducer,
              saga = _ref7.saga,
              onError = _ref7.onError;

          reducer && (reducerMap[fullType] = reducer);
          if (withModule) {
            actions[baseType] = fullType;
            actionCreators[camelBaseType] = createAction.apply(undefined, [fullType].concat(_toConsumableArray(Array.isArray(creator) ? creator : [creator])));
          }
          saga && (sagas[useFullTypeAsKey ? fullType : camelBaseType] = this.initializeMainSaga(saga, fullType, onError));
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = _getIterator(_Object$entries(options.sagas || {})), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _ref5 = _step2.value;

          var _ref6 = _slicedToArray(_ref5, 2);

          var sagaName = _ref6[0];
          var saga = _ref6[1];

          sagas[sagaName] = this.initializeAdditionalSaga(saga, actions, sagaName);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return _Object$assign((_Object$assign2 = {}, _defineProperty(_Object$assign2, this.util.basename(moduleName), handleActions(reducerMap, initialState)), _defineProperty(_Object$assign2, 'sagas', sagas), _Object$assign2), actionCreators, actions);
    }
  }]);

  return Moducks;
}();

export default Moducks;