import _Object$assign from 'babel-runtime/core-js/object/assign';
import _Symbol$toStringTag from 'babel-runtime/core-js/symbol/to-string-tag';
import yup from 'yup';

var requiredFn = yup.mixed().test('required-function', '${path} is not a function', function (v) {
  return typeof v === 'function';
});
var nonRequiredFn = yup.mixed().test('non-required-function', '${path} is not a function', function (v) {
  return v === undefined || typeof v === 'function';
});

var effects = yup.object().transform(function (currentValue, originalValue) {
  return (
    // in webpack v4, wildcard import type is not "Object" but "Module"
    originalValue && originalValue[_Symbol$toStringTag] === 'Module' ? _Object$assign({}, originalValue) : currentValue
  );
}).required().when('defaultEffect', function (defaultEffect, schema) {
  return schema.shape({
    put: requiredFn,
    fork: requiredFn,
    spawn: nonRequiredFn,
    throttle: nonRequiredFn,
    takeEvery: defaultEffect === 'takeEvery' ? requiredFn : nonRequiredFn,
    takeLeading: defaultEffect === 'takeLeading' ? requiredFn : nonRequiredFn,
    takeLatest: defaultEffect === 'takeLatest' ? requiredFn : nonRequiredFn
  });
});

var defaultEffect = yup.string().oneOf(['takeEvery', 'takeLeading', 'takeLatest']).default('takeEvery');

var schema = yup.object().shape({ effects: effects, defaultEffect: defaultEffect });

export default schema;