import _Object$values from 'babel-runtime/core-js/object/values';
import _typeof from 'babel-runtime/helpers/typeof';
import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _Object$assign from 'babel-runtime/core-js/object/assign';
import _slicedToArray from 'babel-runtime/helpers/slicedToArray';
import _Object$entries from 'babel-runtime/core-js/object/entries';
export var IO = '@@redux-saga/IO';

export var mapValues = function mapValues(obj, f) {
  return _Object$entries(obj).reduce(function (prev, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    return _Object$assign({}, prev, _defineProperty({}, key, f(value)));
  }, {});
};

var isGenerator = function isGenerator(obj) {
  return obj && typeof obj.next === 'function' && typeof obj.throw === 'function';
};
export var isGeneratorFunction = function isGeneratorFunction(obj) {
  if (!obj || !obj.constructor) return false;
  if (obj.constructor.name === 'GeneratorFunction' || obj.constructor.displayName === 'GeneratorFunction') return true;
  return isGenerator(obj.constructor.prototype);
};
export var isNormalFunction = function isNormalFunction(obj) {
  if (!obj || !obj.constructor) return false;
  return obj.constructor.name === 'Function' || obj.constructor.displayName === 'Function';
};
export var isForkEffect = function isForkEffect(obj) {
  return obj && obj[IO] && obj.FORK;
};

export var retrieveWorker = function retrieveWorker(saga) {
  if (!isForkEffect(saga)) {
    throw new Error('Invalid saga: The value must be a redux-saga FORK effect.');
  }

  var _arr = [saga.FORK.fn].concat(_toConsumableArray(saga.FORK.args));

  for (var _i = 0; _i < _arr.length; _i++) {
    var arg = _arr[_i];
    if (isGeneratorFunction(arg)) return arg;
  }
  throw new Error('Invalid saga: Generator function not found.');
};
export var retrieveWorkers = function retrieveWorkers(sagas) {
  return mapValues(sagas, retrieveWorker);
};

export var flattenSagas = function flattenSagas() {
  for (var _len = arguments.length, sagas = Array(_len), _key = 0; _key < _len; _key++) {
    sagas[_key] = arguments[_key];
  }

  var storage = [];
  while (sagas.length) {
    var saga = sagas.shift();
    if ((typeof saga === 'undefined' ? 'undefined' : _typeof(saga)) !== 'object' || saga === null) continue;
    if (saga[IO]) storage.push(saga);
    sagas.unshift.apply(sagas, _toConsumableArray(_Object$values(saga)));
  }
  return storage;
};