"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Enhancer = function () {
  function Enhancer(Util, effects) {
    var _this = this;

    (0, _classCallCheck3.default)(this, Enhancer);
    this.enhancibleForkerThunks = {
      takeEvery: function takeEvery(onError) {
        return function (patternOrChannel, worker) {
          for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
            args[_key - 2] = arguments[_key];
          }

          var _effects;

          return (_effects = _this.effects).takeEvery.apply(_effects, [patternOrChannel, _this.enhance(worker, onError)].concat(args));
        };
      },
      takeLeading: function takeLeading(onError) {
        return function (patternOrChannel, worker) {
          for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
            args[_key2 - 2] = arguments[_key2];
          }

          var _effects2;

          return (_effects2 = _this.effects).takeLeading.apply(_effects2, [patternOrChannel, _this.enhance(worker, onError)].concat(args));
        };
      },
      takeLatest: function takeLatest(onError) {
        return function (patternOrChannel, worker) {
          for (var _len3 = arguments.length, args = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
            args[_key3 - 2] = arguments[_key3];
          }

          var _effects3;

          return (_effects3 = _this.effects).takeLatest.apply(_effects3, [patternOrChannel, _this.enhance(worker, onError)].concat(args));
        };
      },
      throttle: function throttle(onError) {
        return function (ms, pattern, worker) {
          for (var _len4 = arguments.length, args = Array(_len4 > 3 ? _len4 - 3 : 0), _key4 = 3; _key4 < _len4; _key4++) {
            args[_key4 - 3] = arguments[_key4];
          }

          var _effects4;

          return (_effects4 = _this.effects).throttle.apply(_effects4, [ms, pattern, _this.enhance(worker, onError)].concat(args));
        };
      },
      fork: function fork(onError) {
        return function (fn) {
          var _effects5;

          for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
            args[_key5 - 1] = arguments[_key5];
          }

          return (_effects5 = _this.effects).fork.apply(_effects5, [_this.enhance(fn, onError)].concat(args));
        };
      },
      spawn: function spawn(onError) {
        return function (fn) {
          var _effects6;

          for (var _len6 = arguments.length, args = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
            args[_key6 - 1] = arguments[_key6];
          }

          return (_effects6 = _this.effects).spawn.apply(_effects6, [_this.enhance(fn, onError)].concat(args));
        };
      }
    };

    this.util = Util;
    this.effects = effects;
    this.enhancedForkers = this.createEnhancedForkers(null);
  }

  (0, _createClass3.default)(Enhancer, [{
    key: "has",
    value: function has(effectName) {
      return this.util.isFunction(this.effects[effectName]);
    }
  }, {
    key: "createEnhancedForkers",
    value: function createEnhancedForkers(onError) {
      var _this2 = this;

      return this.util.mapKeyValues(this.enhancibleForkerThunks, function (_ref) {
        var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
            name = _ref2[0],
            thunk = _ref2[1];

        return _this2.has(name) ? (0, _defineProperty3.default)({}, name, thunk(onError)) : null;
      });
    }
  }, {
    key: "enhance",
    value: function enhance(saga, onError) {
      var self = this;
      return (/*#__PURE__*/_regenerator2.default.mark(function enhancedSaga() {
          for (var _len7 = arguments.length, args = Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
            args[_key7] = arguments[_key7];
          }

          return _regenerator2.default.wrap(function enhancedSaga$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  return _context.delegateYield(self.processFunction.apply(self, [saga].concat(args)), "t0", 2);

                case 2:
                  _context.next = 9;
                  break;

                case 4:
                  _context.prev = 4;
                  _context.t1 = _context["catch"](0);

                  if (onError) {
                    _context.next = 8;
                    break;
                  }

                  throw _context.t1;

                case 8:
                  return _context.delegateYield(self.processFunction.apply(self, [onError, _context.t1].concat(args)), "t2", 9);

                case 9:
                case "end":
                  return _context.stop();
              }
            }
          }, enhancedSaga, this, [[0, 4]]);
        })
      );
    }
  }, {
    key: "putYields",
    value: /*#__PURE__*/_regenerator2.default.mark(function putYields(g) {
      var value, done, _g$next, _g$throw, _g$next2, _g$throw2;

      return _regenerator2.default.wrap(function putYields$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              value = void 0, done = void 0;

              try {
                _g$next = g.next();
                value = _g$next.value;
                done = _g$next.done;
              } catch (e) {
                _g$throw = g.throw(e);
                value = _g$throw.value;
                done = _g$throw.done;
              }

            case 2:
              if (done) {
                _context2.next = 25;
                break;
              }

              _context2.prev = 3;
              _context2.t0 = g;

              if (!this.util.isObject(value)) {
                _context2.next = 11;
                break;
              }

              _context2.next = 8;
              return this.util.isEffect(value) ? value : this.effects.put(value);

            case 8:
              _context2.t1 = _context2.sent;
              _context2.next = 12;
              break;

            case 11:
              _context2.t1 = value;

            case 12:
              _context2.t2 = _context2.t1;
              _g$next2 = _context2.t0.next.call(_context2.t0, _context2.t2);
              value = _g$next2.value;
              done = _g$next2.done;
              _context2.next = 23;
              break;

            case 18:
              _context2.prev = 18;
              _context2.t3 = _context2["catch"](3);
              _g$throw2 = g.throw(_context2.t3);
              value = _g$throw2.value;
              done = _g$throw2.done;

            case 23:
              _context2.next = 2;
              break;

            case 25:
              return _context2.abrupt("return", value);

            case 26:
            case "end":
              return _context2.stop();
          }
        }
      }, putYields, this, [[3, 18]]);
    })
  }, {
    key: "putReturn",
    value: /*#__PURE__*/_regenerator2.default.mark(function putReturn(value) {
      return _regenerator2.default.wrap(function putReturn$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (!this.util.isObject(value)) {
                _context3.next = 3;
                break;
              }

              _context3.next = 3;
              return this.util.isEffect(value) ? value : this.effects.put(value);

            case 3:
            case "end":
              return _context3.stop();
          }
        }
      }, putReturn, this);
    })
  }, {
    key: "processFunction",
    value: /*#__PURE__*/_regenerator2.default.mark(function processFunction(fn) {
      for (var _len8 = arguments.length, args = Array(_len8 > 1 ? _len8 - 1 : 0), _key8 = 1; _key8 < _len8; _key8++) {
        args[_key8 - 1] = arguments[_key8];
      }

      return _regenerator2.default.wrap(function processFunction$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.t0 = this;

              if (!this.util.isGeneratorFunction(fn)) {
                _context4.next = 6;
                break;
              }

              return _context4.delegateYield(this.putYields(fn.apply(undefined, args)), "t2", 3);

            case 3:
              _context4.t1 = _context4.t2;
              _context4.next = 7;
              break;

            case 6:
              _context4.t1 = fn.apply(undefined, args);

            case 7:
              _context4.t3 = _context4.t1;
              return _context4.delegateYield(_context4.t0.putReturn.call(_context4.t0, _context4.t3), "t4", 9);

            case 9:
            case "end":
              return _context4.stop();
          }
        }
      }, processFunction, this);
    })
  }]);
  return Enhancer;
}();

exports.default = Enhancer;