'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Util = function () {
  function Util(IO) {
    (0, _classCallCheck3.default)(this, Util);

    this.IO = IO;
  }

  (0, _createClass3.default)(Util, [{
    key: 'basename',
    value: function basename(fullname) {
      return fullname.replace(/^[\s\S]*\/(?=[^/]*$)/, '');
    }
  }, {
    key: 'mapValues',
    value: function mapValues(obj, f) {
      return (0, _entries2.default)(obj).reduce(function (prev, _ref) {
        var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
            key = _ref2[0],
            value = _ref2[1];

        return (0, _assign2.default)({}, prev, (0, _defineProperty3.default)({}, key, f(value)));
      }, {});
    }
  }, {
    key: 'mapKeyValues',
    value: function mapKeyValues(obj, f) {
      return _assign2.default.apply(Object, [{}].concat((0, _toConsumableArray3.default)((0, _entries2.default)(obj).map(f))));
    }
  }, {
    key: 'isFunction',
    value: function isFunction(obj) {
      return typeof obj === 'function';
    }
  }, {
    key: 'isObject',
    value: function isObject(obj) {
      return (typeof obj === 'undefined' ? 'undefined' : (0, _typeof3.default)(obj)) === 'object' && obj !== null;
    }
  }, {
    key: 'isGenerator',
    value: function isGenerator(obj) {
      return this.isObject(obj) && this.isFunction(obj.next) && this.isFunction(obj.throw);
    }
  }, {
    key: 'isGeneratorFunction',
    value: function isGeneratorFunction(obj) {
      if (!this.isFunction(obj)) return false;
      if (obj.constructor.name === 'GeneratorFunction' || obj.constructor.displayName === 'GeneratorFunction') return true;
      return this.isGenerator(obj.constructor.prototype);
    }
  }, {
    key: 'isEffect',
    value: function isEffect(obj) {
      return this.isObject(obj) && obj[this.IO];
    }
  }, {
    key: 'isForkEffect',
    value: function isForkEffect(obj) {
      return this.isEffect(obj) && this.isObject(obj.FORK) && this.isFunction(obj.FORK.fn) && Array.isArray(obj.FORK.args);
    }
  }, {
    key: 'retrieveWorker',
    value: function retrieveWorker(saga) {
      if (!this.isForkEffect(saga)) {
        throw new Error('Invalid saga: The value must be a redux-saga FORK effect.');
      }

      var _arr = [saga.FORK.fn].concat((0, _toConsumableArray3.default)(saga.FORK.args));

      for (var _i = 0; _i < _arr.length; _i++) {
        var arg = _arr[_i];
        if (this.isGeneratorFunction(arg)) return arg;
      }
      throw new Error('Invalid saga: Generator function not found.');
    }
  }, {
    key: 'retrieveWorkers',
    value: function retrieveWorkers(sagas) {
      return this.mapValues(sagas, this.retrieveWorker.bind(this));
    }
  }, {
    key: 'flattenSagas',
    value: function flattenSagas() {
      var storage = [];

      for (var _len = arguments.length, sagas = Array(_len), _key = 0; _key < _len; _key++) {
        sagas[_key] = arguments[_key];
      }

      while (sagas.length) {
        var saga = sagas.shift();
        if (!this.isObject(saga)) continue;
        if (saga[this.IO]) storage.push(saga);
        sagas.unshift.apply(sagas, (0, _toConsumableArray3.default)((0, _values2.default)(saga)));
      }
      return storage;
    }
  }]);
  return Util;
}();

exports.default = Util;