'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getOwnPropertySymbols = require('babel-runtime/core-js/object/get-own-property-symbols');

var _getOwnPropertySymbols2 = _interopRequireDefault(_getOwnPropertySymbols);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _reduxActions = require('redux-actions');

var _camelCase = require('redux-actions/lib/utils/camelCase');

var _camelCase2 = _interopRequireDefault(_camelCase);

var _schema = require('./schema');

var _schema2 = _interopRequireDefault(_schema);

var _Enhancer = require('./Enhancer');

var _Enhancer2 = _interopRequireDefault(_Enhancer);

var _Util = require('./Util');

var _Util2 = _interopRequireDefault(_Util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Moducks = function () {
  function Moducks(config) {
    (0, _classCallCheck3.default)(this, Moducks);

    this.config = _schema2.default.validateSync(config);
    this.util = new _Util2.default(this.extractIOSymbol());
    this.enhancer = new _Enhancer2.default(this.util, this.config.effects);
  }

  (0, _createClass3.default)(Moducks, [{
    key: 'extractIOSymbol',
    value: function extractIOSymbol() {
      var task = this.config.effects.fork( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
      if ((typeof task === 'undefined' ? 'undefined' : (0, _typeof3.default)(task)) === 'object' && task !== null) {
        var string = '@@redux-saga/IO';
        if (task[string]) return string;
        var symbol = (0, _getOwnPropertySymbols2.default)(task).find(function (symbol) {
          return symbol.toString().startsWith('Symbol(@@redux-saga/IO)');
        });
        if (task[symbol]) return symbol;
      }
      throw new Error('Cannot find symbol: @@redux-saga/IO');
    }
  }, {
    key: 'thunkifyMainGeneratorFunction',
    value: function thunkifyMainGeneratorFunction(saga) {
      var _this = this;

      return function (_ref) {
        var type = _ref.type,
            defaultEffect = _ref[_this.config.defaultEffect];
        return defaultEffect(type, saga);
      };
    }
  }, {
    key: 'thunkifyAdditionalGeneratorFunction',
    value: function thunkifyAdditionalGeneratorFunction(saga) {
      return function (_ref2) {
        var fork = _ref2.fork;
        return fork(saga);
      };
    }
  }, {
    key: 'initializeMainSaga',
    value: function initializeMainSaga(saga, type, onError) {
      var errLabels = ['Invalid saga for ' + type, this.config.defaultEffect];
      return this.initializeSaga(this.thunkifyMainGeneratorFunction, saga, errLabels, { type: type }, onError);
    }
  }, {
    key: 'initializeAdditionalSaga',
    value: function initializeAdditionalSaga(saga, actions, sagaName) {
      var errLabels = ['Invalid additional saga ' + sagaName, 'fork'];
      return this.initializeSaga(this.thunkifyAdditionalGeneratorFunction, saga, errLabels, actions);
    }
  }, {
    key: 'initializeSaga',
    value: function initializeSaga(thunkify, saga, errLabels, actions, onError) {
      var _this2 = this;

      if (typeof saga === 'function') saga = (this.util.isGeneratorFunction(saga) ? thunkify.call(this, saga) : saga)((0, _assign2.default)({}, actions, this.enhancer.createEnhancedForkers(onError), {
        enhance: function enhance(saga) {
          return _this2.enhancer.enhance(saga, onError);
        }
      }));
      if (this.util.isGeneratorFunction(saga)) return this.enhancer.enhancedForkers.fork(saga);
      if (this.util.isForkEffect(saga)) return saga;
      throw new Error(errLabels[0] + ': It must be specified as one of them: \n' + ('  - generator function (=> automatically invoked by enhanced ' + errLabels[1] + '())\n') + '  - thunk that returns generator function (=> automatically invoked by enhanced fork())\n' + '  - thunk that returns redux-saga FORK effect\n' + '  - redux-saga FORK effect');
    }
  }, {
    key: 'createModule',
    value: function createModule(moduleName, definitions) {
      var _Object$assign2;

      var initialState = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      var reducerMap = {};
      var actions = {};
      var actionCreators = {};
      var sagas = {};

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)((0, _entries2.default)(definitions)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref3 = _step.value;

          var _ref4 = (0, _slicedToArray3.default)(_ref3, 2);

          var rawType = _ref4[0];
          var definition = _ref4[1];


          var withApp = this.config.appName && !/^!?([*@])\1/.test(rawType);
          var withModule = !/^!?(?:\*|@{2})/.test(rawType);
          var useFullTypeAsKey = !withModule && /^!/.test(rawType);

          var type = rawType.replace(/^!?\*{0,2}/, '');
          var baseType = this.util.basename(type);
          var camelBaseType = (0, _camelCase2.default)(baseType);
          var fullType = '' + (withApp ? '@@' + this.config.appName + '/' : '') + (withModule ? moduleName + '/' : '') + type;

          var _ref7 = typeof definition === 'function' ? { reducer: definition } : definition,
              creator = _ref7.creator,
              reducer = _ref7.reducer,
              saga = _ref7.saga,
              onError = _ref7.onError;

          reducer && (reducerMap[fullType] = reducer);
          if (withModule) {
            actions[baseType] = fullType;
            actionCreators[camelBaseType] = _reduxActions.createAction.apply(undefined, [fullType].concat((0, _toConsumableArray3.default)(Array.isArray(creator) ? creator : [creator])));
          }
          saga && (sagas[useFullTypeAsKey ? fullType : camelBaseType] = this.initializeMainSaga(saga, fullType, onError));
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (0, _getIterator3.default)((0, _entries2.default)(options.sagas || {})), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _ref5 = _step2.value;

          var _ref6 = (0, _slicedToArray3.default)(_ref5, 2);

          var sagaName = _ref6[0];
          var saga = _ref6[1];

          sagas[sagaName] = this.initializeAdditionalSaga(saga, actions, sagaName);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return (0, _assign2.default)((_Object$assign2 = {}, (0, _defineProperty3.default)(_Object$assign2, this.util.basename(moduleName), (0, _reduxActions.handleActions)(reducerMap, initialState)), (0, _defineProperty3.default)(_Object$assign2, 'sagas', sagas), _Object$assign2), actionCreators, actions);
    }
  }]);
  return Moducks;
}();

exports.default = Moducks;