'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _toStringTag = require('babel-runtime/core-js/symbol/to-string-tag');

var _toStringTag2 = _interopRequireDefault(_toStringTag);

var _yup = require('yup');

var _yup2 = _interopRequireDefault(_yup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var requiredFn = _yup2.default.mixed().test('required-function', '${path} is not a function', function (v) {
  return typeof v === 'function';
});
var nonRequiredFn = _yup2.default.mixed().test('non-required-function', '${path} is not a function', function (v) {
  return v === undefined || typeof v === 'function';
});

var effects = _yup2.default.object().transform(function (currentValue, originalValue) {
  return (
    // in webpack v4, wildcard import type is not "Object" but "Module"
    originalValue && originalValue[_toStringTag2.default] === 'Module' ? (0, _assign2.default)({}, originalValue) : currentValue
  );
}).required().when('defaultEffect', function (defaultEffect, schema) {
  return schema.shape({
    put: requiredFn,
    fork: requiredFn,
    spawn: nonRequiredFn,
    throttle: nonRequiredFn,
    takeEvery: defaultEffect === 'takeEvery' ? requiredFn : nonRequiredFn,
    takeLeading: defaultEffect === 'takeLeading' ? requiredFn : nonRequiredFn,
    takeLatest: defaultEffect === 'takeLatest' ? requiredFn : nonRequiredFn
  });
});

var defaultEffect = _yup2.default.string().oneOf(['takeEvery', 'takeLeading', 'takeLatest']).default('takeEvery');

var schema = _yup2.default.object().shape({ effects: effects, defaultEffect: defaultEffect });

exports.default = schema;