'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.flattenSagas = exports.retrieveWorkers = exports.retrieveWorker = exports.isForkEffect = exports.isNormalFunction = exports.isGeneratorFunction = exports.mapValues = exports.IO = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var IO = exports.IO = '@@redux-saga/IO';

var mapValues = exports.mapValues = function mapValues(obj, f) {
  return (0, _entries2.default)(obj).reduce(function (prev, _ref) {
    var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    return (0, _assign2.default)({}, prev, (0, _defineProperty3.default)({}, key, f(value)));
  }, {});
};

var isGenerator = function isGenerator(obj) {
  return obj && typeof obj.next === 'function' && typeof obj.throw === 'function';
};
var isGeneratorFunction = exports.isGeneratorFunction = function isGeneratorFunction(obj) {
  if (!obj || !obj.constructor) return false;
  if (obj.constructor.name === 'GeneratorFunction' || obj.constructor.displayName === 'GeneratorFunction') return true;
  return isGenerator(obj.constructor.prototype);
};
var isNormalFunction = exports.isNormalFunction = function isNormalFunction(obj) {
  if (!obj || !obj.constructor) return false;
  return obj.constructor.name === 'Function' || obj.constructor.displayName === 'Function';
};
var isForkEffect = exports.isForkEffect = function isForkEffect(obj) {
  return obj && obj[IO] && obj.FORK;
};

var retrieveWorker = exports.retrieveWorker = function retrieveWorker(saga) {
  if (!isForkEffect(saga)) {
    throw new Error('Invalid saga: The value must be a redux-saga FORK effect.');
  }

  var _arr = [saga.FORK.fn].concat((0, _toConsumableArray3.default)(saga.FORK.args));

  for (var _i = 0; _i < _arr.length; _i++) {
    var arg = _arr[_i];
    if (isGeneratorFunction(arg)) return arg;
  }
  throw new Error('Invalid saga: Generator function not found.');
};
var retrieveWorkers = exports.retrieveWorkers = function retrieveWorkers(sagas) {
  return mapValues(sagas, retrieveWorker);
};

var flattenSagas = exports.flattenSagas = function flattenSagas() {
  for (var _len = arguments.length, sagas = Array(_len), _key = 0; _key < _len; _key++) {
    sagas[_key] = arguments[_key];
  }

  var storage = [];
  while (sagas.length) {
    var saga = sagas.shift();
    if ((typeof saga === 'undefined' ? 'undefined' : (0, _typeof3.default)(saga)) !== 'object' || saga === null) continue;
    if (saga[IO]) storage.push(saga);
    sagas.unshift.apply(sagas, (0, _toConsumableArray3.default)((0, _values2.default)(saga)));
  }
  return storage;
};